﻿Option Strict On
Public Class Form1
    Const ForwardPx = 30
    Dim rnd As New Random
    Dim nowQuestion As Question
    Dim timeCount As Double
    Dim qTimeCount As Double
    Dim qTimes As New List(Of Double)

    Private Sub TextBox1_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        Dim chrs = {"0"c, "1"c, "2"c, "3"c, "4"c, "5"c, "6"c, "7"c, "8"c, "9"c, Chr(Keys.Back)}
        If Not chrs.Contains(e.KeyChar) Then e.Handled = True
    End Sub

    Private Sub Form1_HelpButtonClicked(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.HelpButtonClicked
        MessageBox.Show(String.Format(
               "[スタート]をクリックすることでゲームを開始します。{0}計算問題を解くことでランナーのアオピが進みます。アオピが右端のゴールまでたどり着けばゲームオーバーです。{0}問題は全{1}問。ランダムに出題されます。{0}{0}※除算の問題は小数点以下切り捨てです。",
               Environment.NewLine, GamePictureBox1.ClientSize.Width \ ForwardPx + 1),
               "ヘルプ", MessageBoxButtons.OK, MessageBoxIcon.Information)
        e.Cancel = True
    End Sub

    Private Sub SetQuestion(ByVal q As Question)
        qTimeCount = 0
        nowQuestion = q
        QuestionLabel.Text = q.ToString
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click
        GamePictureBox1.RunnerLeft = 0
        GamePictureBox1.RunnerVisible = True
        timeCount = 0
        qTimes.Clear()
        MainTimer.Start()
        TextBox1.Enabled = True
        StartButton.Enabled = False
        SetQuestion(Question.Create(rnd))
        AQuestionTimer.Start()
        TextBox1.Focus()
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        If TextBox1.Text = nowQuestion.Answer.ToString Then
            AQuestionTimer.Stop()
            qTimes.Add(qTimeCount)
            GamePictureBox1.RunnerLeft += ForwardPx
            If GamePictureBox1.RunnerLeft >= GamePictureBox1.ClientSize.Width Then
                'ゲームオーバー
                MainTimer.Stop()
                MessageBox.Show(String.Format(
                                "お疲れ様でした！{0}{0}結果{0}タイム：{1:0.0}秒{0}1問平均：{2:0.0}秒{0}ランク：{3}",
                                Environment.NewLine, timeCount, qTimes.Average, GetRank(timeCount)),
                            "ゲームオーバー")
                TextBox1.Clear()
                TextBox1.Enabled = False
                StartButton.Enabled = True
                StartButton.Focus()
                QuestionLabel.Text = New Question() With {.N1 = 0, .N2 = 0, .Type = CalType.Add}.ToString
                GamePictureBox1.RunnerVisible = False
            Else
                TextBox1.Clear()
                SetQuestion(Question.Create(rnd))
                AQuestionTimer.Start()
            End If
        End If
    End Sub

    Private Sub MainTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MainTimer.Tick
        timeCount += 0.1
    End Sub

    Private Sub AQuestionTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AQuestionTimer.Tick
        qTimeCount += 0.1
    End Sub

    Private Function GetRank(ByVal time As Double) As String
        Select Case time
            Case Is < 10
                Return "SS"
            Case Is < 15
                Return "S"
            Case Is < 20
                Return "A"
            Case Is < 30
                Return "B"
            Case Is < 50
                Return "C"
            Case Else
                Return "D"
        End Select
    End Function
End Class
