﻿Public Class Question
    Public Property N1 As Integer
    Public Property N2 As Integer
    Public Property Type As CalType
    Public ReadOnly Property Answer As Integer
        Get
            Select Case Type
                Case CalType.Add
                    Return N1 + N2
                Case CalType.Subtraction
                    Return N1 - N2
                Case CalType.Multiplication
                    Return N1 * N2
                Case CalType.Division
                    Return N1 \ N2
                Case Else
                    Throw New Exception("CalTypeが正しくありません。")
            End Select
        End Get
    End Property
    Public Overrides Function ToString() As String
        Dim strType As String
        Select Case Type
            Case CalType.Add
                strType = "＋"
            Case CalType.Subtraction
                strType = "－"
            Case CalType.Multiplication
                strType = "×"
            Case CalType.Division
                strType = "÷"
            Case Else
                Throw New Exception("CalTypeが正しくありません。")
        End Select
        Return String.Format("{0} {1} {2} ＝", N1, strType, N2)
    End Function
    Public Shared Function Create(ByVal rnd As Random) As Question
        Dim re As New Question
        With re
            .Type = CType(rnd.Next(4), CalType)
            Select Case .Type
                Case CalType.Add
                    .N1 = rnd.Next(100)
                    .N2 = rnd.Next(100)
                Case CalType.Subtraction
                    .N1 = rnd.Next(100)
                    .N2 = rnd.Next(.N1)
                Case CalType.Multiplication
                    .N1 = rnd.Next(20)
                    .N2 = rnd.Next(10)
                Case CalType.Division
                    .N1 = rnd.Next(20)
                    .N2 = rnd.Next(1, Math.Min(10, .N1))
            End Select
        End With
        Return re
    End Function
End Class

Public Enum CalType
    Add
    Subtraction
    Multiplication
    Division
End Enum